#once

#include "lcd5110.s"

; Library Functions
; Video_Intro
; Video_PlayBackFlash
; Audio_PlayBackFlash

;;;;;;;;;;;;;;;;;;;;;;;;

; Flash address where the video is stored
Video_Data = 0x050000
Audio_Data = 0x050000

Video_Intro_Str1:
    #d "16-bit Serial\0"
Video_Intro_Str2:
    #d "Homebrew CPU\0"
Video_Intro_Str3:
    #d "presents\0"
Video_Intro_Str4:
    #d "Bad Apple!!\0"
Video_Intro:
    PUSH_PC
    PUSH RA
    CALL LCD_Clear
    LCD_SetXY 3, 0
    LCD_WriteDelayedStrF delay10MHz_ms(50), Video_Intro_Str1
    LCD_SetXY 6, 1
    LCD_WriteDelayedStrF delay10MHz_ms(50), Video_Intro_Str2
    LCD_SetXY 6, 3
    LCD_WriteDelayedStrF delay10MHz_ms(50), Video_Intro_Str3
    LDI RA, 3-1
.loop:
    DelayCycles delay10MHz_ms(250)
    LCD_WriteChar 46
    DEC RA
    BRFC .loop
    DelayCycles delay10MHz_ms(500)
    LCD_SetXY 6, 4
    LCD_WriteDelayedStrF delay10MHz_ms(50), Video_Intro_Str4
    DelayCycles delay10MHz_ms(1500)
    POP RA
    POP_PC
    RET

Video_PlayBackFlash:
    PUSH_PC
    LCD_SetXY 0, 0
    LDIW FA, Video_Data
    REV32 FB, FA
    LDI FE, 0xFF
.start_next_decompression:
    LPB__ FC, FB + 1
    INC FA
    BRFC .skip_reversing_upper_addr1
    ADDI FA+2, 1
    REV FB, FA+2
.skip_reversing_upper_addr1:
    REV FB+2, FA
    BREQ FC, .stop      ; decompression is 0x00
    ANDI TMP, FC, 0x80
    BRFS .decompress_color
    ANDI FD, FC, 0x7F
.decompress_data:
    DEC FD
    BRFS .start_next_decompression
    LPM__ FC, FB + 1
    ADDI FA, 2
    BRFC .skip_reversing_upper_addr2
    ADCI FA+2, 0
    REV FB, FA+2
.skip_reversing_upper_addr2:
    REV FB+2, FA
    OUT_LCD FC
    OUT_LCD FC+1
    LPM__ FC, FB + 1
    ADDI FA, 2
    BRFC .skip_reversing_upper_addr3
    ADCI FA+2, 0
    REV FB, FA+2
.skip_reversing_upper_addr3:
    REV FB+2, FA
    OUT_LCD FC
    OUT_LCD FC+1
    JMP .decompress_data
.decompress_color:
    ANDI TMP, FC, 0x40
    BRFS .decompress_white
    ANDI FD, FC, 0x3F
.decompress_black:
    DEC FD
    BRFS .start_next_decompression
    OUT_LCD FE
    OUT_LCD FE
    OUT_LCD FE
    OUT_LCD FE
    JMP .decompress_black
.decompress_white:
    ANDI FD, FC, 0x3F
.decompress_white_loop:
    DEC FD
    BRFS .start_next_decompression
    OUT_LCD FE+1
    OUT_LCD FE+1
    OUT_LCD FE+1
    OUT_LCD FE+1
    JMP .decompress_white_loop
.stop:
    DelayCycles delay10MHz_ms(4000)
    POP_PC
    RET

Audio_PlayBackFlash:
    PUSH_PC
    LDIW FA, Audio_Data
    REV FB, FA+2
    LDI FB+2, 0
    LDI FC, 0x8000
.loop:
    OUT FC+1                        ; 795
    LPM__ FC, FB + 1                ; 884
    ADDI FB+2, 1                    ; 774
    OUT FC                          ; 795
    ANDI FB+2, FB+2, 0x7FFF         ; 774
    BRFC .loop                      ; 625
    ADDI FA+2, 1
    REV FB, FA+2
    JMP .loop
.stop:
    POP_PC
    RET

